diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lte/model/lte-rlc.cc ns-3.34/src/lte/model/lte-rlc.cc
--- ns-3.33/src/lte/model/lte-rlc.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lte/model/lte-rlc.cc	2021-07-14 10:31:07.000000000 -0700
@@ -112,6 +112,11 @@
                      "PDU received.",
                      MakeTraceSourceAccessor (&LteRlc::m_rxPdu),
                      "ns3::LteRlc::ReceiveTracedCallback")
+    .AddTraceSource ("TxDrop",
+                     "Trace source indicating a packet "
+                     "has been dropped before transmission",
+                     MakeTraceSourceAccessor (&LteRlc::m_txDropTrace),
+                     "ns3::Packet::TracedCallback")
   ;
   return tid;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lte/model/lte-rlc.h ns-3.34/src/lte/model/lte-rlc.h
--- ns-3.33/src/lte/model/lte-rlc.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lte/model/lte-rlc.h	2021-07-14 10:31:07.000000000 -0700
@@ -176,6 +176,11 @@
    * Used to inform of a PDU reception from the MAC SAP user
    */
   TracedCallback<uint16_t, uint8_t, uint32_t, uint64_t> m_rxPdu;
+  /**
+   * The trace source fired when the RLC drops a packet before
+   * transmission.
+   */
+  TracedCallback<Ptr<const Packet> > m_txDropTrace;
 
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lte/model/lte-rlc-um.cc ns-3.34/src/lte/model/lte-rlc-um.cc
--- ns-3.33/src/lte/model/lte-rlc-um.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lte/model/lte-rlc-um.cc	2021-07-14 10:31:07.000000000 -0700
@@ -111,6 +111,7 @@
       NS_LOG_LOGIC ("MaxTxBufferSize = " << m_maxTxBufferSize);
       NS_LOG_LOGIC ("txBufferSize    = " << m_txBufferSize);
       NS_LOG_LOGIC ("packet size     = " << p->GetSize ());
+      m_txDropTrace (p);
     }
 
   /** Report Buffer Status */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lte/model/lte-rrc-protocol-real.cc ns-3.34/src/lte/model/lte-rrc-protocol-real.cc
--- ns-3.33/src/lte/model/lte-rrc-protocol-real.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lte/model/lte-rrc-protocol-real.cc	2021-07-14 10:31:07.000000000 -0700
@@ -448,9 +448,12 @@
 {
   std::map<uint16_t, LteUeRrcSapProvider*>::iterator it;
   it = m_enbRrcSapProviderMap.find (rnti);
-  NS_ASSERT_MSG (it != m_enbRrcSapProviderMap.end (), "Cell id " << m_cellId
-                                         << " could not find RNTI = " << rnti);
-  it->second = p;
+  // TODO: remove after merge of ho_failure branch
+  // assign UE RRC only if the RNTI is found at eNB
+  if (it != m_enbRrcSapProviderMap.end ())
+    {
+      it->second = p;
+    }
 }
 
 void 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lte/model/lte-spectrum-phy.cc ns-3.34/src/lte/model/lte-spectrum-phy.cc
--- ns-3.33/src/lte/model/lte-spectrum-phy.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lte/model/lte-spectrum-phy.cc	2021-07-14 10:31:07.000000000 -0700
@@ -267,7 +267,7 @@
 
 
 Ptr<MobilityModel>
-LteSpectrumPhy::GetMobility ()
+LteSpectrumPhy::GetMobility () const
 {
   NS_LOG_FUNCTION (this);
   return m_mobility;
@@ -404,7 +404,7 @@
 
 
 Ptr<AntennaModel>
-LteSpectrumPhy::GetRxAntenna ()
+LteSpectrumPhy::GetRxAntenna () const
 {
   return m_antenna;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lte/model/lte-spectrum-phy.h ns-3.34/src/lte/model/lte-spectrum-phy.h
--- ns-3.33/src/lte/model/lte-spectrum-phy.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lte/model/lte-spectrum-phy.h	2021-07-14 10:31:07.000000000 -0700
@@ -177,10 +177,10 @@
   void SetChannel (Ptr<SpectrumChannel> c);
   void SetMobility (Ptr<MobilityModel> m);
   void SetDevice (Ptr<NetDevice> d);
-  Ptr<MobilityModel> GetMobility ();
+  Ptr<MobilityModel> GetMobility () const;
   Ptr<NetDevice> GetDevice () const;
   Ptr<const SpectrumModel> GetRxSpectrumModel () const;
-  Ptr<AntennaModel> GetRxAntenna ();
+  Ptr<AntennaModel> GetRxAntenna () const;
   void StartRx (Ptr<SpectrumSignalParameters> params);
   /**
    * \brief Start receive data function
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lte/model/lte-ue-rrc.cc ns-3.34/src/lte/model/lte-ue-rrc.cc
--- ns-3.33/src/lte/model/lte-ue-rrc.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lte/model/lte-ue-rrc.cc	2021-07-14 10:31:07.000000000 -0700
@@ -1359,7 +1359,7 @@
       uint16_t dlBand = scell.radioResourceConfigCommonSCell.nonUlConfiguration.dlBandwidth;
       uint32_t dlEarfcn = scell.cellIdentification.dlCarrierFreq;
       uint8_t txMode = scell.radioResourceConfigDedicateSCell.physicalConfigDedicatedSCell.antennaInfo.transmissionMode;
-      uint8_t srsIndex = scell.radioResourceConfigDedicateSCell.physicalConfigDedicatedSCell.soundingRsUlConfigDedicated.srsConfigIndex;
+      uint16_t srsIndex = scell.radioResourceConfigDedicateSCell.physicalConfigDedicatedSCell.soundingRsUlConfigDedicated.srsConfigIndex;
 
       m_cphySapProvider.at (ccId)->SynchronizeWithEnb (physCellId, dlEarfcn);
       m_cphySapProvider.at (ccId)->SetDlBandwidth (dlBand);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lte/model/rem-spectrum-phy.cc ns-3.34/src/lte/model/rem-spectrum-phy.cc
--- ns-3.33/src/lte/model/rem-spectrum-phy.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lte/model/rem-spectrum-phy.cc	2021-07-14 10:31:07.000000000 -0700
@@ -97,7 +97,7 @@
 }
 
 Ptr<MobilityModel>
-RemSpectrumPhy::GetMobility ()
+RemSpectrumPhy::GetMobility () const
 {
   return m_mobility;
 }
@@ -115,7 +115,7 @@
 }
 
 Ptr<AntennaModel>
-RemSpectrumPhy::GetRxAntenna ()
+RemSpectrumPhy::GetRxAntenna () const
 {
   return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lte/model/rem-spectrum-phy.h ns-3.34/src/lte/model/rem-spectrum-phy.h
--- ns-3.33/src/lte/model/rem-spectrum-phy.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lte/model/rem-spectrum-phy.h	2021-07-14 10:31:07.000000000 -0700
@@ -67,10 +67,10 @@
   void SetChannel (Ptr<SpectrumChannel> c);
   void SetMobility (Ptr<MobilityModel> m);
   void SetDevice (Ptr<NetDevice> d);
-  Ptr<MobilityModel> GetMobility ();
+  Ptr<MobilityModel> GetMobility () const;
   Ptr<NetDevice> GetDevice () const;
   Ptr<const SpectrumModel> GetRxSpectrumModel () const;
-  Ptr<AntennaModel> GetRxAntenna ();
+  Ptr<AntennaModel> GetRxAntenna () const;
   void StartRx (Ptr<SpectrumSignalParameters> params);
 
   /** 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lte/test/lte-simple-spectrum-phy.cc ns-3.34/src/lte/test/lte-simple-spectrum-phy.cc
--- ns-3.33/src/lte/test/lte-simple-spectrum-phy.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lte/test/lte-simple-spectrum-phy.cc	2021-07-14 10:31:07.000000000 -0700
@@ -81,7 +81,7 @@
 
 
 Ptr<MobilityModel>
-LteSimpleSpectrumPhy::GetMobility ()
+LteSimpleSpectrumPhy::GetMobility () const
 {
   NS_LOG_FUNCTION (this);
   return m_mobility;
@@ -119,7 +119,7 @@
 
 
 Ptr<AntennaModel>
-LteSimpleSpectrumPhy::GetRxAntenna ()
+LteSimpleSpectrumPhy::GetRxAntenna () const
 {
   return m_antenna;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lte/test/lte-simple-spectrum-phy.h ns-3.34/src/lte/test/lte-simple-spectrum-phy.h
--- ns-3.33/src/lte/test/lte-simple-spectrum-phy.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lte/test/lte-simple-spectrum-phy.h	2021-07-14 10:31:07.000000000 -0700
@@ -63,10 +63,10 @@
   void SetChannel (Ptr<SpectrumChannel> c);
   void SetMobility (Ptr<MobilityModel> m);
   void SetDevice (Ptr<NetDevice> d);
-  Ptr<MobilityModel> GetMobility ();
+  Ptr<MobilityModel> GetMobility () const;
   Ptr<NetDevice> GetDevice () const;
   Ptr<const SpectrumModel> GetRxSpectrumModel () const;
-  Ptr<AntennaModel> GetRxAntenna ();
+  Ptr<AntennaModel> GetRxAntenna () const;
   void StartRx (Ptr<SpectrumSignalParameters> params);
 
   /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lte/test/lte-test-rlc-am-e2e.cc ns-3.34/src/lte/test/lte-test-rlc-am-e2e.cc
--- ns-3.33/src/lte/test/lte-test-rlc-am-e2e.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lte/test/lte-test-rlc-am-e2e.cc	2021-07-14 10:31:07.000000000 -0700
@@ -149,6 +149,8 @@
   Config::SetDefault ("ns3::LteRlcAm::PollRetransmitTimer", TimeValue (MilliSeconds (20)));
   Config::SetDefault ("ns3::LteRlcAm::ReorderingTimer", TimeValue (MilliSeconds (10)));
   Config::SetDefault ("ns3::LteRlcAm::StatusProhibitTimer", TimeValue (MilliSeconds (40)));
+  // This test was written for an unlimited transmit buffer (special value of 0)
+  Config::SetDefault ("ns3::LteRlcAm::MaxTxBufferSize", UintegerValue (0));
 
   Ptr<LteSimpleHelper> lteSimpleHelper = CreateObject<LteSimpleHelper> ();
   // lteSimpleHelper->EnableLogComponents ();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lte/test/test-lte-antenna.cc ns-3.34/src/lte/test/test-lte-antenna.cc
--- ns-3.33/src/lte/test/test-lte-antenna.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lte/test/test-lte-antenna.cc	2021-07-14 10:31:07.000000000 -0700
@@ -158,8 +158,12 @@
   lteHelper->SetSchedulerAttribute ("UlCqiFilter", EnumValue (FfMacScheduler::PUSCH_UL_CQI));
   lteHelper->SetEnbAntennaModelType ("ns3::CosineAntennaModel");
   lteHelper->SetEnbAntennaModelAttribute ("Orientation", DoubleValue (m_orientationDegrees));
-  lteHelper->SetEnbAntennaModelAttribute ("Beamwidth",   DoubleValue (m_beamwidthDegrees));
-  lteHelper->SetEnbAntennaModelAttribute ("MaxGain",     DoubleValue (0.0));
+  lteHelper->SetEnbAntennaModelAttribute ("HorizontalBeamwidth", DoubleValue (m_beamwidthDegrees));
+  lteHelper->SetEnbAntennaModelAttribute ("MaxGain", DoubleValue (0.0));
+
+  // set DL and UL bandwidth. 
+  lteHelper->SetEnbDeviceAttribute ("DlBandwidth", UintegerValue (25));
+  lteHelper->SetEnbDeviceAttribute ("UlBandwidth", UintegerValue (25));
 
   enbDevs = lteHelper->InstallEnbDevice (enbNodes);
   ueDevs = lteHelper->InstallUeDevice (ueNodes);
@@ -220,6 +224,7 @@
         }      
       // remember that propagation loss is 0dB
       double calculatedAntennaGainDbDl = - (enbTxPowerDbm - calculatedSinrDbDl - noisePowerDbm - ueNoiseFigureDb);      
+      NS_LOG_INFO ("expected " << m_antennaGainDb << " actual " << calculatedAntennaGainDbDl << " tol " << tolerance);
       NS_TEST_ASSERT_MSG_EQ_TOL (calculatedAntennaGainDbDl, m_antennaGainDb, tolerance, "Wrong DL antenna gain!");
     }
   double expectedSinrUl = ueTxPowerDbm + m_antennaGainDb - noisePowerDbm + enbNoiseFigureDb;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/mesh/bindings/callbacks_list.py ns-3.34/src/mesh/bindings/callbacks_list.py
--- ns-3.33/src/mesh/bindings/callbacks_list.py	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/mesh/bindings/callbacks_list.py	2021-07-14 10:31:07.000000000 -0700
@@ -6,17 +6,27 @@
     ['void', 'ns3::Ptr<ns3::NetDevice>', 'ns3::Ptr<const ns3::Packet>', 'unsigned short', 'const ns3::Address &', 'const ns3::Address &', 'ns3::NetDevice::PacketType', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<ns3::NetDevice>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'bool', 'ns3::Ptr<ns3::Packet>', 'ns3::Mac48Address', 'ns3::Mac48Address', 'unsigned short', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['unsigned short', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['unsigned long', 'unsigned short', 'unsigned short', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['unsigned long', 'const ns3::WifiTxVector &', 'unsigned short', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['unsigned long', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['bool', 'unsigned short', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Mac48Address', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::Mac48Address', 'ns3::Mac48Address', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Mac48Address', 'unsigned char', 'bool', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Mac48Address', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'const ns3::WifiMacHeader &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::WifiMacQueueItem>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Time', 'ns3::Mac48Address', 'unsigned char', 'ns3::OriginatorBlockAckAgreement::State', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::WifiMacDropReason', 'ns3::Ptr<const ns3::WifiMacQueueItem>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'unsigned int', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Time', 'ns3::Time', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Mac48Address', 'ns3::Mac48Address', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'const ns3::WifiMacHeader &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'unsigned char', 'ns3::Ptr<const ns3::WifiMacQueueItem>', 'const ns3::WifiTxVector &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'unsigned char', 'ns3::Ptr<const ns3::WifiPsdu>', 'const ns3::WifiTxVector &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'unsigned char', 'std::unordered_map<unsigned short, ns3::Ptr<ns3::WifiPsdu>, std::hash<unsigned short>, std::equal_to<unsigned short>, std::allocator<std::pair<const unsigned short, ns3::Ptr<ns3::WifiPsdu> > > > *', 'const std::set<ns3::Mac48Address, std::less<ns3::Mac48Address>, std::allocator<ns3::Mac48Address> > *', 'unsigned long', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['unsigned int', 'ns3::Mac48Address', 'ns3::Ptr<ns3::MeshWifiInterfaceMac>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['std::vector<ns3::Mac48Address, std::allocator<ns3::Mac48Address> >', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Time', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/mesh/helper/mesh-helper.cc ns-3.34/src/mesh/helper/mesh-helper.cc
--- ns-3.33/src/mesh/helper/mesh-helper.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/mesh/helper/mesh-helper.cc	2021-07-14 10:31:07.000000000 -0700
@@ -27,7 +27,9 @@
 #include "ns3/minstrel-wifi-manager.h"
 #include "ns3/mesh-wifi-interface-mac.h"
 #include "ns3/wifi-helper.h"
-#include "ns3/wifi-ack-policy-selector.h"
+#include "ns3/frame-exchange-manager.h"
+#include "ns3/wifi-default-protection-manager.h"
+#include "ns3/wifi-default-ack-manager.h"
 
 namespace ns3
 {
@@ -97,11 +99,11 @@
           uint32_t channel = 0;
           if (m_spreadChannelPolicy == ZERO_CHANNEL)
             {
-              channel = 0;
+              channel = 100;
             }
           if (m_spreadChannelPolicy == SPREAD_CHANNELS)
             {
-              channel = i * 5;
+              channel = 100 + i * 5;
             }
           Ptr<WifiNetDevice> iface = CreateInterface (phyHelper, node, channel);
           mp->AddInterface (iface);
@@ -120,10 +122,6 @@
   MeshHelper helper;
   helper.SetMacType ();
   helper.SetRemoteStationManager ("ns3::ArfWifiManager");
-  helper.SetAckPolicySelectorForAc (AC_BE, "ns3::ConstantWifiAckPolicySelector");
-  helper.SetAckPolicySelectorForAc (AC_BK, "ns3::ConstantWifiAckPolicySelector");
-  helper.SetAckPolicySelectorForAc (AC_VI, "ns3::ConstantWifiAckPolicySelector");
-  helper.SetAckPolicySelectorForAc (AC_VO, "ns3::ConstantWifiAckPolicySelector");
   helper.SetSpreadInterfaceChannels (SPREAD_CHANNELS);
   return helper;
 }
@@ -170,28 +168,6 @@
   m_stationManager.Set (n6, v6);
   m_stationManager.Set (n7, v7);
 }
-void
-MeshHelper::SetAckPolicySelectorForAc (AcIndex ac, std::string type,
-                                       std::string n0, const AttributeValue &v0,
-                                       std::string n1, const AttributeValue &v1,
-                                       std::string n2, const AttributeValue &v2,
-                                       std::string n3, const AttributeValue &v3,
-                                       std::string n4, const AttributeValue &v4,
-                                       std::string n5, const AttributeValue &v5,
-                                       std::string n6, const AttributeValue &v6,
-                                       std::string n7, const AttributeValue &v7)
-{
-  m_ackPolicySelector[ac] = ObjectFactory ();
-  m_ackPolicySelector[ac].SetTypeId (type);
-  m_ackPolicySelector[ac].Set (n0, v0);
-  m_ackPolicySelector[ac].Set (n1, v1);
-  m_ackPolicySelector[ac].Set (n2, v2);
-  m_ackPolicySelector[ac].Set (n3, v3);
-  m_ackPolicySelector[ac].Set (n4, v4);
-  m_ackPolicySelector[ac].Set (n5, v5);
-  m_ackPolicySelector[ac].Set (n6, v6);
-  m_ackPolicySelector[ac].Set (n7, v7);
-}
 void 
 MeshHelper::SetStandard (enum WifiStandard standard)
 {
@@ -219,35 +195,24 @@
   Ptr<WifiPhy> phy = phyHelper.Create (node, device);
   mac->SetAddress (Mac48Address::Allocate ());
   mac->ConfigureStandard (m_standard);
+  Ptr<RegularWifiMac> wifiMac = DynamicCast<RegularWifiMac> (mac);
+  Ptr<FrameExchangeManager> fem;
+  if (wifiMac != 0 && (fem = wifiMac->GetFrameExchangeManager ()) != 0)
+    {
+      Ptr<WifiProtectionManager> protectionManager = CreateObject<WifiDefaultProtectionManager> ();
+      protectionManager->SetWifiMac (wifiMac);
+      fem->SetProtectionManager (protectionManager);
+
+      Ptr<WifiAckManager> ackManager = CreateObject<WifiDefaultAckManager> ();
+      ackManager->SetWifiMac (wifiMac);
+      fem->SetAckManager (ackManager);
+    }
   phy->ConfigureStandardAndBand (it->second.phyStandard, it->second.phyBand);
   device->SetMac (mac);
   device->SetPhy (phy);
   device->SetRemoteStationManager (manager);
   node->AddDevice (device);
   mac->SwitchFrequencyChannel (channelId);
-  // Install ack policy selector
-  PointerValue ptr;
-  Ptr<WifiAckPolicySelector> ackSelector;
-
-  mac->GetAttributeFailSafe ("BE_Txop", ptr);
-  ackSelector = m_ackPolicySelector[AC_BE].Create<WifiAckPolicySelector> ();
-  ackSelector->SetQosTxop (ptr.Get<QosTxop> ());
-  ptr.Get<QosTxop> ()->SetAckPolicySelector (ackSelector);
-
-  mac->GetAttributeFailSafe ("BK_Txop", ptr);
-  ackSelector = m_ackPolicySelector[AC_BK].Create<WifiAckPolicySelector> ();
-  ackSelector->SetQosTxop (ptr.Get<QosTxop> ());
-  ptr.Get<QosTxop> ()->SetAckPolicySelector (ackSelector);
-
-  mac->GetAttributeFailSafe ("VI_Txop", ptr);
-  ackSelector = m_ackPolicySelector[AC_VI].Create<WifiAckPolicySelector> ();
-  ackSelector->SetQosTxop (ptr.Get<QosTxop> ());
-  ptr.Get<QosTxop> ()->SetAckPolicySelector (ackSelector);
-
-  mac->GetAttributeFailSafe ("VO_Txop", ptr);
-  ackSelector = m_ackPolicySelector[AC_VO].Create<WifiAckPolicySelector> ();
-  ackSelector->SetQosTxop (ptr.Get<QosTxop> ());
-  ptr.Get<QosTxop> ()->SetAckPolicySelector (ackSelector);
 
   return device;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/mesh/helper/mesh-helper.h ns-3.34/src/mesh/helper/mesh-helper.h
--- ns-3.33/src/mesh/helper/mesh-helper.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/mesh/helper/mesh-helper.h	2021-07-14 10:31:07.000000000 -0700
@@ -122,38 +122,6 @@
                            std::string n6 = "", const AttributeValue &v6 = EmptyAttributeValue (),
                            std::string n7 = "", const AttributeValue &v7 = EmptyAttributeValue ());
   /**
-   * \param ac the Access Category to attach the ack policy selector to.
-   * \param type the type of ns3::WifiAckPolicySelector to create.
-   * \param n0 the name of the attribute to set
-   * \param v0 the value of the attribute to set
-   * \param n1 the name of the attribute to set
-   * \param v1 the value of the attribute to set
-   * \param n2 the name of the attribute to set
-   * \param v2 the value of the attribute to set
-   * \param n3 the name of the attribute to set
-   * \param v3 the value of the attribute to set
-   * \param n4 the name of the attribute to set
-   * \param v4 the value of the attribute to set
-   * \param n5 the name of the attribute to set
-   * \param v5 the value of the attribute to set
-   * \param n6 the name of the attribute to set
-   * \param v6 the value of the attribute to set
-   * \param n7 the name of the attribute to set
-   * \param v7 the value of the attribute to set
-   *
-   * All the attributes specified in this method should exist
-   * in the requested ack policy selector.
-   */
-  void SetAckPolicySelectorForAc (AcIndex ac, std::string type,
-                                  std::string n0 = "", const AttributeValue &v0 = EmptyAttributeValue (),
-                                  std::string n1 = "", const AttributeValue &v1 = EmptyAttributeValue (),
-                                  std::string n2 = "", const AttributeValue &v2 = EmptyAttributeValue (),
-                                  std::string n3 = "", const AttributeValue &v3 = EmptyAttributeValue (),
-                                  std::string n4 = "", const AttributeValue &v4 = EmptyAttributeValue (),
-                                  std::string n5 = "", const AttributeValue &v5 = EmptyAttributeValue (),
-                                  std::string n6 = "", const AttributeValue &v6 = EmptyAttributeValue (),
-                                  std::string n7 = "", const AttributeValue &v7 = EmptyAttributeValue ());
-  /**
    * Set standard
    * \param standard the wifi phy standard
    */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/mesh/model/dot11s/hwmp-protocol.cc ns-3.34/src/mesh/model/dot11s/hwmp-protocol.cc
--- ns-3.33/src/mesh/model/dot11s/hwmp-protocol.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/mesh/model/dot11s/hwmp-protocol.cc	2021-07-14 10:31:07.000000000 -0700
@@ -92,7 +92,7 @@
                     MakeTimeChecker ()
                     )
     .AddAttribute ( "Dot11MeshHWMPactiveRootTimeout",
-                    "Lifetime of poractive routing information",
+                    "Lifetime of proactive routing information",
                     TimeValue (MicroSeconds (1024*5000)),
                     MakeTimeAccessor (
                       &HwmpProtocol::m_dot11MeshHWMPactiveRootTimeout),
@@ -113,7 +113,7 @@
                     MakeTimeChecker ()
                     )
     .AddAttribute ( "Dot11MeshHWMPrannInterval",
-                    "Lifetime of poractive routing information",
+                    "Lifetime of proactive routing information",
                     TimeValue (MicroSeconds (1024*5000)),
                     MakeTimeAccessor (
                       &HwmpProtocol::m_dot11MeshHWMPrannInterval),
@@ -141,7 +141,7 @@
                     MakeUintegerChecker<uint8_t> (1)
                     )
     .AddAttribute ( "UnicastDataThreshold",
-                    "Maximum number ofbroadcast receivers, when we send a broadcast as a chain of unicasts",
+                    "Maximum number of broadcast receivers, when we send a broadcast as a chain of unicasts",
                     UintegerValue (1),
                     MakeUintegerAccessor (
                       &HwmpProtocol::m_unicastDataThreshold),
